/**
 * @module @zk-kit/imt
 * @version 2.0.0-beta.1
 * @file Incremental Merkle tree implementations in TypeScript.
 * @copyright Ethereum Foundation 2024
 * @license MIT
 * @see [Github]{@link https://github.com/privacy-scaling-explorations/zk-kit/tree/main/packages/imt}
*/
var zkKitImt=function(e){"use strict";function t(e,t){for(var r=[],o=2;o<arguments.length;o++)r[o-2]=arguments[o];if(void 0===e)throw new TypeError("Parameter '".concat(t,"' is not defined"));if(!r.includes(typeof e))throw new TypeError("Parameter '".concat(t,"' is none of these types: ").concat(r.join(", ")))}var r=function(){function e(e,r,o,i,n){var s;if(void 0===i&&(i=2),void 0===n&&(n=[]),t(e,"hash","function"),t(r,"depth","number"),t(o,"zeroValue","number","string","bigint"),t(i,"arity","number"),t(n,"leaves","object"),n.length>Math.pow(i,r))throw new Error("The tree cannot contain more than ".concat(Math.pow(i,r)," leaves"));this._hash=e,this._depth=r,this._zeroes=[],this._nodes=[],this._arity=i;for(var h=0;h<r;h+=1)this._zeroes.push(o),this._nodes[h]=[],o=e(Array(this._arity).fill(o));if(this._nodes[r]=[],n.length>0){this._nodes[0]=n;for(h=0;h<r;h+=1)for(var a=0;a<Math.ceil(this._nodes[h].length/i);a+=1){for(var f=a*i,p=[],d=0;d<i;d+=1)p.push(null!==(s=this._nodes[h][f+d])&&void 0!==s?s:this.zeroes[h]);this._nodes[h+1][a]=e(p)}}else this._nodes[r][0]=o;Object.freeze(this._zeroes),Object.freeze(this._nodes)}return Object.defineProperty(e.prototype,"root",{get:function(){return this._nodes[this.depth][0]},enumerable:!1,configurable:!0}),Object.defineProperty(e.prototype,"depth",{get:function(){return this._depth},enumerable:!1,configurable:!0}),Object.defineProperty(e.prototype,"leaves",{get:function(){return this._nodes[0].slice()},enumerable:!1,configurable:!0}),Object.defineProperty(e.prototype,"zeroes",{get:function(){return this._zeroes},enumerable:!1,configurable:!0}),Object.defineProperty(e.prototype,"arity",{get:function(){return this._arity},enumerable:!1,configurable:!0}),e.prototype.indexOf=function(e){return t(e,"leaf","number","string","bigint"),this._nodes[0].indexOf(e)},e.prototype.insert=function(e){if(t(e,"leaf","number","string","bigint"),this._nodes[0].length>=Math.pow(this.arity,this.depth))throw new Error("The tree is full");for(var r=e,o=this._nodes[0].length,i=0;i<this.depth;i+=1){var n=o-o%this.arity,s=n+this.arity,h=[];this._nodes[i][o]=r;for(var a=n;a<s;a+=1)a<this._nodes[i].length?h.push(this._nodes[i][a]):h.push(this._zeroes[i]);r=this._hash(h),o=Math.floor(o/this.arity)}this._nodes[this.depth][0]=r},e.prototype.delete=function(e){this.update(e,this.zeroes[0])},e.prototype.update=function(e,r){if(t(e,"index","number"),e<0||e>=this._nodes[0].length)throw new Error("The leaf does not exist in this tree");for(var o=r,i=0;i<this.depth;i+=1){var n=e-e%this.arity,s=n+this.arity,h=[];this._nodes[i][e]=o;for(var a=n;a<s;a+=1)a<this._nodes[i].length?h.push(this._nodes[i][a]):h.push(this.zeroes[i]);o=this._hash(h),e=Math.floor(e/this.arity)}this._nodes[this.depth][0]=o},e.prototype.createProof=function(e){if(t(e,"index","number"),e<0||e>=this._nodes[0].length)throw new Error("The leaf does not exist in this tree");for(var r=[],o=[],i=e,n=0;n<this.depth;n+=1){var s=e%this.arity,h=e-s,a=h+this.arity;o[n]=s,r[n]=[];for(var f=h;f<a;f+=1)f!==e&&(f<this._nodes[n].length?r[n].push(this._nodes[n][f]):r[n].push(this.zeroes[n]));e=Math.floor(e/this.arity)}return{root:this.root,leaf:this._nodes[0][i],pathIndices:o,siblings:r,leafIndex:i}},e.prototype.verifyProof=function(e){t(e,"proof","object"),t(e.root,"proof.root","number","string","bigint"),t(e.leaf,"proof.leaf","number","string","bigint"),t(e.siblings,"proof.siblings","object"),t(e.pathIndices,"proof.pathElements","object");for(var r=e.leaf,o=0;o<e.siblings.length;o+=1){var i=e.siblings[o].slice();i.splice(e.pathIndices[o],0,r),r=this._hash(i)}return e.root===r},e}();function o(e,t){if(void 0===e)throw new TypeError("Parameter '".concat(t,"' is not defined"))}function i(e,t){if("number"!=typeof e)throw new TypeError("Parameter '".concat(t,"' is not a number"))}function n(e,t){if("object"!=typeof e&&!Array.isArray(e))throw new TypeError("Parameter '".concat(t,"' is not an array"))}var s=function(){function e(e,t){void 0===t&&(t=[]),o(e,"hash"),function(e,t){if("function"!=typeof e)throw new TypeError("Parameter '".concat(t,"' is not a function"))}(e,"hash"),n(t,"leaves"),this._nodes=[[]],this._hash=e,t.length>0&&this.insertMany(t)}return Object.defineProperty(e.prototype,"root",{get:function(){return this._nodes[this.depth][0]},enumerable:!1,configurable:!0}),Object.defineProperty(e.prototype,"depth",{get:function(){return this._nodes.length-1},enumerable:!1,configurable:!0}),Object.defineProperty(e.prototype,"leaves",{get:function(){return this._nodes[0].slice()},enumerable:!1,configurable:!0}),Object.defineProperty(e.prototype,"size",{get:function(){return this._nodes[0].length},enumerable:!1,configurable:!0}),e.prototype.indexOf=function(e){return o(e,"leaf"),this._nodes[0].indexOf(e)},e.prototype.has=function(e){return o(e,"leaf"),this._nodes[0].includes(e)},e.prototype.insert=function(e){o(e,"leaf"),this.depth<Math.ceil(Math.log2(this.size+1))&&this._nodes.push([]);for(var t=e,r=this.size,i=0;i<this.depth;i+=1){if(this._nodes[i][r]=t,1&r){var n=this._nodes[i][r-1];t=this._hash(n,t)}r>>=1}this._nodes[this.depth]=[t]},e.prototype.insertMany=function(e){var t;if(o(e,"leaves"),n(e,"leaves"),0===e.length)throw new Error("There are no leaves to add");var r=this.size>>1;(t=this._nodes[0]).push.apply(t,e);for(var i=Math.ceil(Math.log2(this.size))-this.depth,s=0;s<i;s+=1)this._nodes.push([]);for(var h=0;h<this.depth;h+=1){for(var a=Math.ceil(this._nodes[h].length/2),f=r;f<a;f+=1){var p=this._nodes[h][2*f+1],d=this._nodes[h][2*f],u=p?this._hash(d,p):d;this._nodes[h+1][f]=u}r>>=1}},e.prototype.update=function(e,t){o(e,"index"),o(t,"newLeaf"),i(e,"index");for(var r=t,n=0;n<this.depth;n+=1){if(this._nodes[n][e]=r,1&e){var s=this._nodes[n][e-1];r=this._hash(s,r)}else{(s=this._nodes[n][e+1])&&(r=this._hash(r,s))}e>>=1}this._nodes[this.depth]=[r]},e.prototype.generateProof=function(e){if(o(e,"index"),i(e,"index"),e<0||e>=this.size)throw new Error("The leaf at index '".concat(e,"' does not exist in this tree"));for(var t=this.leaves[e],r=[],n=[],s=0;s<this.depth;s+=1){var h=1&e,a=h?e-1:e+1,f=this._nodes[s][a];void 0!==f&&(n.push(h),r.push(f)),e>>=1}return{root:this.root,leaf:t,index:Number.parseInt(n.reverse().join(""),2),siblings:r}},e.prototype.verifyProof=function(e){o(e,"proof");var t=e.root,r=e.leaf,s=e.siblings,h=e.index;o(e.root,"proof.root"),o(e.leaf,"proof.leaf"),o(e.siblings,"proof.siblings"),o(e.index,"proof.index"),n(e.siblings,"proof.siblings"),i(e.index,"proof.index");for(var a=r,f=0;f<s.length;f+=1)a=h>>f&1?this._hash(s[f],a):this._hash(a,s[f]);return t===a},e.prototype.export=function(){return JSON.stringify(this._nodes,(function(e,t){return"bigint"==typeof t?t.toString():t}))},e.prototype.import=function(e){if(o(e,"nodes"),function(e,t){if("string"!=typeof e)throw new TypeError("Parameter '".concat(t,"' is not a string"))}(e,"nodes"),0!==this.size)throw new Error("Import failed: the target tree structure is not empty");this._nodes=JSON.parse(e)},e}();return e.IMT=r,e.LeanIMT=s,Object.defineProperty(e,"__esModule",{value:!0}),e}({});
